(function capsule(window) {
  function defineLibrary() {
    const Random = {};

    class Generator {
/*

  // Takes any integer
      constructor(i) {
        this.m_w = 123456789;
        this.m_z = 987654321;
        this.mask = 0xffffffff;
        this.m_w = (123456789 + i) & this.mask;
        this.m_z = (987654321 - i) & this.mask;
      }

  // Returns number between 0 (inclusive) and 1.0 (exclusive),
  // just like Random.random().
      random() {
        this.m_z = (36969 * (this.m_z & 65535) + (this.m_z >> 16)) & this.mask;
        this.m_w = (18000 * (this.m_w & 65535) + (this.m_w >> 16)) & this.mask;
        let result = ((this.m_z << 16) + (this.m_w & 65535)) >>> 0;
        result /= 4294967296;
        return result;
      }
      */
      constructor(a, b, c, d) {
        this.a = a;
        this.b = b;
        this.c = c;
        this.d = d;
      }

      random() {
        this.a >>>= 0; this.b >>>= 0; this.c >>>= 0; this.d >>>= 0;
        let t = (this.a + this.b) | 0;
        this.a = this.b ^ this.b >>> 9;
        this.b = this.c + (this.c << 3) | 0;
        this.c = (this.c << 21 | this.c >>> 11);
        this.d = this.d + 1 | 0;
        t = t + this.d | 0;
        this.c = this.c + t | 0;
        return (t >>> 0) / 4294967296;
      }
}

    Random.Generator = Generator;

    const basic = new Generator(29173, 11743, 40609, 91813);

    Random.random = basic.random;

    return Random;
  }
// define globally if it doesn't already exist
  if (typeof (Random) === 'undefined') {
    const mwindow = window;
    mwindow.Random = defineLibrary();
  }
}(window)); // eslint-disable-line no-undef
