    // This music has been exported by SoundBox. You can use it with
    // http://sb.bitsnbites.eu/player-small.js in your own product.

    // See http://sb.bitsnbites.eu/demo.html for an example of how to
    // use it in a demo.

    // Song data
    var song = {
      songData: [
        { // Instrument 0
          i: [
          2, // OSC1_WAVEFORM
          56, // OSC1_VOL
          128, // OSC1_SEMI
          0, // OSC1_XENV
          2, // OSC2_WAVEFORM
          127, // OSC2_VOL
          128, // OSC2_SEMI
          3, // OSC2_DETUNE
          1, // OSC2_XENV
          8, // NOISE_VOL
          0, // ENV_ATTACK
          113, // ENV_SUSTAIN
          0, // ENV_RELEASE
          5, // ARP_CHORD
          4, // ARP_SPEED
          0, // LFO_WAVEFORM
          195, // LFO_AMT
          6, // LFO_FREQ
          1, // LFO_FX_FREQ
          3, // FX_FILTER
          126, // FX_FREQ
          32, // FX_RESONANCE
          0, // FX_DIST
          53, // FX_DRIVE
          190, // FX_PAN_AMT
          8, // FX_PAN_FREQ
          139, // FX_DELAY_AMT
          7 // FX_DELAY_TIME
          ],
          // Patterns
          p: [1,2,3,4,1,2,3,4,1,2,3,4],
          // Columns
          c: [
            {n: [144],
             f: []},
            {n: [142],
             f: []},
            {n: [147],
             f: []},
            {n: [140],
             f: []}
          ]
        },
        { // Instrument 1
          i: [
          2, // OSC1_WAVEFORM
          100, // OSC1_VOL
          128, // OSC1_SEMI
          0, // OSC1_XENV
          2, // OSC2_WAVEFORM
          201, // OSC2_VOL
          128, // OSC2_SEMI
          3, // OSC2_DETUNE
          1, // OSC2_XENV
          12, // NOISE_VOL
          0, // ENV_ATTACK
          40, // ENV_SUSTAIN
          0, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          195, // LFO_AMT
          6, // LFO_FREQ
          0, // LFO_FX_FREQ
          2, // FX_FILTER
          137, // FX_FREQ
          0, // FX_RESONANCE
          1, // FX_DIST
          51, // FX_DRIVE
          113, // FX_PAN_AMT
          6, // FX_PAN_FREQ
          71, // FX_DELAY_AMT
          6 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,1,2,3,4,1,2,3,4,1,2,3,4],
          // Columns
          c: [
            {n: [108,,120,,108,,120,,108,,120,,108,,120,,108,,120,,108,,120,,108,,120,,108,,120],
             f: []},
            {n: [106,,118,,106,,118,,106,,118,,106,,118,,106,,118,,106,,118,,106,,118,,106,,118],
             f: []},
            {n: [111,,123,,111,,123,,111,,123,,111,,123,,111,,123,,111,,123,,111,,123,,111,,123],
             f: []},
            {n: [104,,116,,104,,116,,104,,116,,104,,116,,104,,116,,104,,116,,104,,116,,104,,116],
             f: []}
          ]
        },
        { // Instrument 2
          i: [
          1, // OSC1_WAVEFORM
          192, // OSC1_VOL
          128, // OSC1_SEMI
          0, // OSC1_XENV
          1, // OSC2_WAVEFORM
          191, // OSC2_VOL
          116, // OSC2_SEMI
          9, // OSC2_DETUNE
          0, // OSC2_XENV
          0, // NOISE_VOL
          6, // ENV_ATTACK
          22, // ENV_SUSTAIN
          34, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          69, // LFO_AMT
          3, // LFO_FREQ
          1, // LFO_FX_FREQ
          1, // FX_FILTER
          23, // FX_FREQ
          167, // FX_RESONANCE
          0, // FX_DIST
          32, // FX_DRIVE
          77, // FX_PAN_AMT
          6, // FX_PAN_FREQ
          113, // FX_DELAY_AMT
          6 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,,,,,1,2,3,4,1,2,3,4],
          // Columns
          c: [
            {n: [144,,144,,147,,149,,144,,144,,142,,144,,144,,144,,147,,149,,144,,144,,142,,144],
             f: []},
            {n: [142,,142,,145,,147,,142,,142,,140,,142,,142,,142,,145,,147,,142,,142,,140,,142],
             f: []},
            {n: [147,,147,,150,,152,,147,,147,,145,,147,,147,,147,,150,,152,,147,,147,,145,,147],
             f: []},
            {n: [140,,140,,143,,145,,140,,140,,138,,140,,140,,140,,143,,145,,140,,140,,138,,140],
             f: []}
          ]
        },
        { // Instrument 3
          i: [
          0, // OSC1_WAVEFORM
          221, // OSC1_VOL
          128, // OSC1_SEMI
          1, // OSC1_XENV
          0, // OSC2_WAVEFORM
          210, // OSC2_VOL
          128, // OSC2_SEMI
          0, // OSC2_DETUNE
          1, // OSC2_XENV
          255, // NOISE_VOL
          0, // ENV_ATTACK
          0, // ENV_SUSTAIN
          35, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          64, // LFO_AMT
          7, // LFO_FREQ
          1, // LFO_FX_FREQ
          3, // FX_FILTER
          107, // FX_FREQ
          13, // FX_RESONANCE
          0, // FX_DIST
          146, // FX_DRIVE
          20, // FX_PAN_AMT
          0, // FX_PAN_FREQ
          24, // FX_DELAY_AMT
          2 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,,,,,,,,1,2,2,2,2],
          // Columns
          c: [
            {n: [,,,,,,,,,,,,,,,,142,,142,,142,,142,,142,,142,142,142,142,142,142],
             f: []},
            {n: [,,,,142,,,,,,,,142,,,,,,,,142,,,,,,,,142],
             f: []}
          ]
        },
        { // Instrument 4
          i: [
          0, // OSC1_WAVEFORM
          255, // OSC1_VOL
          116, // OSC1_SEMI
          1, // OSC1_XENV
          0, // OSC2_WAVEFORM
          255, // OSC2_VOL
          116, // OSC2_SEMI
          0, // OSC2_DETUNE
          1, // OSC2_XENV
          0, // NOISE_VOL
          4, // ENV_ATTACK
          6, // ENV_SUSTAIN
          35, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          0, // LFO_AMT
          0, // LFO_FREQ
          0, // LFO_FX_FREQ
          2, // FX_FILTER
          14, // FX_FREQ
          0, // FX_RESONANCE
          0, // FX_DIST
          68, // FX_DRIVE
          0, // FX_PAN_AMT
          0, // FX_PAN_FREQ
          0, // FX_DELAY_AMT
          0 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,,,,,,,,,1,1,1,1],
          // Columns
          c: [
            {n: [142,,,,142,,,,142,,,,142,,,,142,,,,142,,,,142,,,,142],
             f: []}
          ]
        },
        { // Instrument 5
          i: [
          0, // OSC1_WAVEFORM
          0, // OSC1_VOL
          140, // OSC1_SEMI
          0, // OSC1_XENV
          0, // OSC2_WAVEFORM
          0, // OSC2_VOL
          140, // OSC2_SEMI
          0, // OSC2_DETUNE
          0, // OSC2_XENV
          60, // NOISE_VOL
          4, // ENV_ATTACK
          10, // ENV_SUSTAIN
          34, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          187, // LFO_AMT
          5, // LFO_FREQ
          0, // LFO_FX_FREQ
          1, // FX_FILTER
          239, // FX_FREQ
          135, // FX_RESONANCE
          0, // FX_DIST
          32, // FX_DRIVE
          108, // FX_PAN_AMT
          5, // FX_PAN_FREQ
          16, // FX_DELAY_AMT
          4 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,,,,,,,,,1,1,1,1],
          // Columns
          c: [
            {n: [147,,147,,147,,147,,147,,147,,147,,147,,147,,147,,147,,147,,147,,147,,147,,147],
             f: []}
          ]
        },
      ],
      rowLen: 5752,   // In sample lengths
      patternLen: 32,  // Rows per pattern
      endPattern: 15,  // End pattern
      numChannels: 6  // Number of channels
    };
